const showHideInputCategory = (self, inputTextEl, valueItem) => {
  if (self.value == 'custom') {
    inputTextEl.value = '';
    inputTextEl.style.display = 'inline-block';
    valueItem.value = true;
  } else {
    inputTextEl.style.display = 'none';
    inputTextEl.value = self.value;
    valueItem.value = false;
  }
}

const removeOne = (self) => {
  getRequest('/wp-json/click5_sitemap/API/get_custom_url_delete_one?ID=' + self.getAttribute('data-value'), (data) => {
      if (data == true) {
        self.parentElement.parentElement.remove();
        click5_sitemap_notification('success', 'Settings saved.', 2000);

        if (!document.querySelectorAll('#custom_urls_list > li').length) {
          document.getElementById('click5_no_records_found').style.display = 'block';
          document.getElementById('custom_urls_list').style.display = 'none';
          document.getElementById('click5_clear_custom_list').style.display = 'none';
        }
      }
  });
}

const toggleEditCustom = (self) => {
  getRequest('/wp-json/click5_sitemap/API/get_custom_url_single?ID=' + self.getAttribute('data-value'), (data) => {
      if (data !== false) {
        document.getElementById('edit_url_title').value = data.title;
        document.getElementById('edit_url_url').value = data.url;
        if (data.category.use_custom) {
          document.getElementById('edit_url_category_select').value = 'custom';
          document.getElementById('edit_url_category_text').value = data.category.name;
          document.getElementById('edit_url_category_text').style.display = 'inline-block';
          document.getElementById('edit_url_category_use_custom').value = true;
        } else {
          document.getElementById('edit_url_category_text').value = data.category.name;
          document.getElementById('edit_url_category_text').style.display = 'none';
          document.getElementById('edit_url_category_select').value = data.category.name;
          document.getElementById('edit_url_category_use_custom').value = false;
        }

        document.getElementById('edit_url_category_select').addEventListener('change', function(e) {
          showHideInputCategory(this, document.getElementById('edit_url_category_text'), document.getElementById('edit_url_category_use_custom'));
        });

        document.getElementById('edit_url_open_new_tab').checked = data.new_tab;
        document.getElementById('edit_url_last_mod_date').value = data.last_mod;

        document.getElementById('saveURLbtn').setAttribute('data-value', data.ID);

        document.getElementById('edit_custom_url').style.display = 'block';

        //showHideInputCategory(this, document.getElementById('edit_url_category_text'), document.getElementById('edit_url_category_use_custom'));
      }
  });
}

const validAddNew = () => {
  if (!document.getElementById('add_url_title').value.length) {
    return false;
  }

  if (!document.getElementById('add_url_url').value.length) {
    return false;
  }

  if (!document.getElementById('add_url_category_text').value.length) {
    return false;
  }

  return true;
}

const loadCustomURLSlist = () => {
  document.querySelectorAll('#custom_urls_list > li').forEach(el => el.remove());
  toggleLoader('loader_custom_urls_list', true);
  document.getElementById('click5_no_records_found').style.display = 'none';
  document.getElementById('custom_urls_list').style.display = 'none';
  getRequest('/wp-json/click5_sitemap/API/get_custom_url_list', (data) => {
    toggleLoader('loader_custom_urls_list', false);

    if (!hasElementsArr(data)) {
      document.getElementById('click5_clear_custom_list').style.display = 'none';
      document.getElementById('click5_no_records_found').style.display = 'block';
    } else {
      document.getElementById('custom_urls_list').style.display = 'block';
      document.getElementById('click5_clear_custom_list').style.display = 'block';
      data.forEach(el => {
        let newListElement = document.createElement('li');
        let urlElement = document.createElement('a');
        urlElement.setAttribute('href', el.url);
        urlElement.setAttribute('target', '_blank');
        urlElement.innerHTML = '[' + el.category.name + '] ' + el.title;
        newListElement.appendChild(urlElement);
        let controlsOfElement = document.createElement('div');
        controlsOfElement.className = 'click5_sitemap_float_right click5_controls';
        controlsOfElement.style.display = 'flex';
        controlsOfElement.innerHTML += '<label><input type="checkbox" class="click5_custom_urls_enabledHTML" data-value="' + el.ID + '" value="1" ' + (el.enabledHTML ? 'checked' : '') + '>HTML</label>';
        controlsOfElement.innerHTML += '<label><input type="checkbox" class="click5_custom_urls_enabledXML" data-value="' + el.ID + '" value="1" ' + (el.enabledXML ? 'checked' : '') + '>XML</label>';
        controlsOfElement.innerHTML += '<a href="#" data-value="' + el.ID + '" class="click5_includedCustomRemove">Remove</a>';
        controlsOfElement.innerHTML += '<a href="#" data-value="' + el.ID + '" class="click5_includedCustomEdit">Edit</a>';
        newListElement.appendChild(controlsOfElement);

        document.getElementById('custom_urls_list').appendChild(newListElement);
      });
      document.querySelectorAll('.click5_includedCustomRemove').forEach(el => {
        el.addEventListener('click', function (e) {
          e.preventDefault();
          e.stopPropagation();

          removeOne(this);
        });
      });
      document.querySelectorAll('.click5_includedCustomEdit').forEach(el => {
        el.addEventListener('click', function (e) {
          e.preventDefault();
          e.stopPropagation();

          toggleEditCustom(this);
        });
      });
      document.querySelectorAll('.click5_custom_urls_enabledHTML').forEach(el => {
        el.addEventListener('change', function (e) {
          e.preventDefault();
          e.stopPropagation();

          let isChecked = e.target.checked;
          getRequest('/wp-json/click5_sitemap/API/get_custom_url_toggle_HTML?ID=' + this.getAttribute('data-value') + '&newVal=' + isChecked, (data) => {
            if (data == true) {
              click5_sitemap_notification('success', 'Settings saved.', 2000);
            }
          });
        });
      });
      document.querySelectorAll('.click5_custom_urls_enabledXML').forEach(el => {
        el.addEventListener('change', function (e) {
          e.preventDefault();
          e.stopPropagation();

          let isChecked = e.target.checked;
          getRequest('/wp-json/click5_sitemap/API/get_custom_url_toggle_XML?ID=' + this.getAttribute('data-value') + '&newVal=' + isChecked, (data) => {
            if (data == true) {
              click5_sitemap_notification('success', 'Settings saved.', 2000);
            }
          });
        });
      });
    }
  })
}

const addNewURL = () => {
  if (!validAddNew()) {
    click5_sitemap_notification('warning', 'Fill all required New Custom URL fields!', 2000);
    return;
  }

  const object = {
    title: document.getElementById('add_url_title').value,
    url: document.getElementById('add_url_url').value,
    category: {
      use_custom: document.getElementById('add_url_category_use_custom').value == 'true',
      name: document.getElementById('add_url_category_text').value
    },
    new_tab: document.getElementById('add_url_open_new_tab').checked,
    last_mod: document.getElementById('add_url_last_mod_date').value
  };

  document.getElementById('add_url_title').value = '';
  document.getElementById('add_url_url').value = '';
  document.getElementById('add_url_category_use_custom').value = 'true';
  document.getElementById('add_url_category_text').value = '';
  document.getElementById('add_url_open_new_tab').checked = false;
  document.getElementById('add_url_last_mod_date').value = '';


  postRequestJSON('/wp-json/click5_sitemap/API/add_custom_url', object, (data) => {
      if (data == true) {
        click5_sitemap_notification('success', 'New custom URL has been added.', 2000);

        document.querySelectorAll('#custom_urls_list > li').forEach(el => {
          el.remove();
        });

        toggleLoader('loader_custom_urls_list', true);
        loadCustomURLSlist();
      } else {
        click5_sitemap_notification('error', 'Something went wrong.', 2000);
      }
  });
}

const saveEdition = (id) => {
  const object = {
    ID: id,
    title: document.getElementById('edit_url_title').value,
    url: document.getElementById('edit_url_url').value,
    category: {
      use_custom: document.getElementById('edit_url_category_use_custom').value == 'true',
      name: document.getElementById('edit_url_category_text').value
    },
    new_tab: document.getElementById('edit_url_open_new_tab').checked,
    last_mod: document.getElementById('edit_url_last_mod_date').value
  };

  postRequestJSON('/wp-json/click5_sitemap/API/post_custom_url_save_edit?ID=' + id, object, (data) => {
    if (data == true) {
      click5_sitemap_notification('success', 'URL saved.', 2000);
      document.getElementById('edit_custom_url').style.display = 'none';
      loadCustomURLSlist();
    } else {
      click5_sitemap_notification('error', 'Something went wrong.', 2000);
    }
  });
}

(() => {
  document.addEventListener("DOMContentLoaded", function (event) {
    if (!hasParameter('&tab=urls')) {
      return;
    }
    toggleLoader('loader_custom_urls_list', true);
    loadCustomURLSlist();
    showHideInputCategory(document.getElementById('add_url_category_select'), document.getElementById('add_url_category_text'), document.getElementById('add_url_category_use_custom'));
    document.getElementById('add_url_category_select').addEventListener('change', function(e) {
      showHideInputCategory(this, document.getElementById('add_url_category_text'), document.getElementById('add_url_category_use_custom'));
    });

    document.getElementById('addNewURLbtn').addEventListener('click', function(e) {
      e.preventDefault();
      e.stopPropagation();

      addNewURL();
    });

    document.getElementById('click5_clear_custom_list').addEventListener('click', function(e) {
      e.stopPropagation();
      e.preventDefault();

      if (confirm('Are you sure you want delete all Custom URLs?')) {
        postRequest('/wp-json/click5_sitemap/API/post_custom_url_clear', '', (data) => {
          if (data == true) {
            click5_sitemap_notification('success', 'Settings saved.', 2000);
            loadCustomURLSlist();
          }
        });
      }

    });

    document.getElementById('cancelURLbtn').addEventListener('click', function(e) {
      e.preventDefault();
      e.stopPropagation();

      document.getElementById('edit_custom_url').style.display = 'none';
    });

    document.getElementById('saveURLbtn').addEventListener('click', function(e) {
      e.preventDefault();
      e.stopPropagation();

      const idEdit = this.getAttribute('data-value');
      saveEdition(idEdit);
    });
  });
})();